//this file is part of aMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://sourceforge.net/projects/amule )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// ServerWnd.cpp : implementation file
//

//#include "stdafx.h"
#include "wintypes.h"
#include "amule.h"
#include "ServerWnd.h"
//#include "HttpDownloadDlg.h"
#include "HTTPDownloadDlg.h"
#include "config.h"

// CServerWnd dialog
#include "muuli_wdr.h"
#include <wx/settings.h>

//IMPLEMENT_DYNAMIC(CServerWnd, CDialog)
IMPLEMENT_DYNAMIC_CLASS(CServerWnd,wxPanel)

BEGIN_EVENT_TABLE(CServerWnd,wxPanel)
  EVT_BUTTON(ID_ADDTOLIST,CServerWnd::OnBnClickedAddserver)
  EVT_BUTTON(ID_UPDATELIST,CServerWnd::OnBnClickedUpdateservermetfromurl)
  EVT_BUTTON(ID_BTN_RESET, CServerWnd::OnBnClickedResetLog)
END_EVENT_TABLE()

#include <wx/textctrl.h>

CServerWnd::CServerWnd(wxWindow* pParent /*=NULL*/)
  : wxPanel(pParent,CServerWnd::IDD)
{
  SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_WINDOWFRAME));
  wxSizer* content=serverListDlg(this,TRUE);
  content->Show(this,TRUE);

  // init serverlist
  // no use now. too early.
  CServerListCtrl* list=(CServerListCtrl*)wxFindWindowByName("serverListCtrl");
  //list->Init(theApp.serverlist);
  serverlistctrl=list;

  wxTextCtrl* cv=(wxTextCtrl*)FindWindowByName("serverInfo");
  cv->AppendText(wxString(_("This is "))+wxString("aMule")+wxString(" ")+wxString(VERSION)+wxString(_(" (based on "))+wxString(_("eMule"))+wxString(")\n"));
  cv->AppendText(wxString(_("Visit http://amule.sourceforge.net to check if a new version is available.\n")));
//  cv->AppendText(GetResString(IDS_EMULEW)+wxString(" "));
//  cv->AppendText(GetResString(IDS_EMULEW3)+wxString(" "));
//  cv->AppendText(GetResString(IDS_EMULEW2)+wxString("\n\n"));
}

CServerWnd::~CServerWnd(){
}

void CServerWnd::UpdateServerMetFromURL(wxString strURL) {
  if (strURL.Find("://") == -1)	// not a valid URL
    {
      theApp.amuledlg->AddLogLine(true, GetResString(IDS_INVALIDURL) );
      return;
    }
  
  wxString strTempFilename;
  strTempFilename=wxString::Format("%stemp-%d-server.met", theApp.glob_prefs->GetAppDir(), ::GetTickCount());
  
  CHTTPDownloadDlg *dlg=new CHTTPDownloadDlg(this,strURL,strTempFilename);
  int retval=dlg->ShowModal();
  if(retval==0) {
    // wget succeeded. proceed with serverlist processing
    serverlistctrl->AddServermetToList(strTempFilename);
    wxRemoveFile(strTempFilename);
    theApp.serverlist->SaveServermetToFile();
  } else {
      theApp.amuledlg->AddLogLine(true, GetResString(IDS_ERR_FAILEDDOWNLOADMET).GetData(), strURL.GetData());
  }
  delete dlg;

}

void CServerWnd::Localize() {
}

// CServerWnd message handlers

void CServerWnd::OnBnClickedAddserver(wxEvent& evt){
  wxString serveraddr;
  if(((wxTextCtrl*)FindWindowByName("ipAddress"))->GetLineText(0).IsEmpty()) {
    //if (!GetDlgItem(IDC_IPADDRESS)->GetWindowTextLength()){
    theApp.amuledlg->AddLogLine(true, GetResString(IDS_SRV_ADDR) );
    return;
  }
  else
    serveraddr=((wxTextCtrl*)FindWindowByName("ipAddress"))->GetLineText(0);
  //GetDlgItem(IDC_IPADDRESS)->GetWindowText(serveraddr);
  
  //if (!GetDlgItem(IDC_SPORT)->GetWindowTextLength()){
  if(((wxTextCtrl*)FindWindowByName("portNumber"))->GetLineText(0).IsEmpty()) {
    theApp.amuledlg->AddLogLine(true, GetResString(IDS_SRV_PORT) );
    return;
  }
  
  //char portstr[6];
  //GetDlgItem(IDC_SPORT)->GetWindowText(portstr,6);
  wxString portstr;
  portstr=((wxTextCtrl*)FindWindowByName("portNumber"))->GetLineText(0);
  CServer* toadd = new CServer(atoi(portstr.GetData()),(char*)serveraddr.GetData());
  
  //int32 namelen = GetDlgItem(IDC_SNAME)->GetWindowTextLength();
  wxString servername;
  servername=((wxTextCtrl*)FindWindowByName("serverName"))->GetLineText(0);
  if (!servername.IsEmpty()){
    //char* servername = new char[namelen+2];
    //GetDlgItem(IDC_SNAME)->GetWindowText(servername,namelen+1);
    toadd->SetListName((char*)servername.GetData());
    //delete[] servername;
  }
  else{
    toadd->SetListName((char*)serveraddr.GetData());
  }
  if (!serverlistctrl->AddServer(toadd,true)){
    CServer* update = theApp.serverlist->GetServerByAddress(toadd->GetAddress(), toadd->GetPort());
    if(update){
      update->SetListName(toadd->GetListName());
      serverlistctrl->RefreshServer(update);
    }
    delete toadd;
    theApp.amuledlg->AddLogLine(true, GetResString(IDS_SRV_NOTADDED) );
  } else theApp.amuledlg->AddLogLine(true,GetResString(IDS_SERVERADDED)+"%s", toadd->GetListName());
  theApp.serverlist->SaveServermetToFile();
  ((wxTextCtrl*)FindWindowByName("serverName"))->SetValue("");
  ((wxTextCtrl*)FindWindowByName("ipAddress"))->SetValue("");
  ((wxTextCtrl*)FindWindowByName("portNumber"))->SetValue("");
}

void CServerWnd::OnBnClickedUpdateservermetfromurl(wxEvent& evt)
{
  wxString strURL;
  strURL=((wxTextCtrl*)FindWindowByName("serverlistURL"))->GetLineText(0);

  UpdateServerMetFromURL(strURL);
}

void CServerWnd::OnBnClickedResetLog(wxEvent& evt) {theApp.amuledlg->ResetLog(); }

void CServerWnd::UpdateMyInfo() {
#if 0
	CString buffer;

	MyInfoList->DeleteAllItems();
	MyInfoList->InsertItem(0,GetResString(IDS_STATUS)+":");
	if (theApp.serverconnect->IsConnected())
		MyInfoList->SetItemText(0, 1, GetResString(IDS_CONNECTED ));
	else MyInfoList->SetItemText(0, 1, GetResString(IDS_DISCONNECTED )); 

	if (theApp.serverconnect->IsConnected()) {
		MyInfoList->InsertItem(1,GetResString(IDS_IP) +":"+GetResString(IDS_PORT) );
		if (theApp.serverconnect->IsLowID()) buffer=GetResString(IDS_UNKNOWN); else {
			uint32 myid=theApp.serverconnect->GetClientID();
			uint8 d=myid/(256*256*256);myid-=d*(256*256*256);
			uint8 c=myid/(256*256);myid-=c*256*256;
			uint8 b=myid/(256);myid-=b*256;
			buffer.Format("%i.%i.%i.%i:%i",myid,b,c,d,theApp.glob_prefs->GetPort());
		}
		MyInfoList->SetItemText(1,1,buffer);

		buffer.Format("%u",theApp.serverconnect->GetClientID());
		MyInfoList->InsertItem(2,GetResString(IDS_ID));
		if (theApp.serverconnect->IsConnected()) MyInfoList->SetItemText(2, 1, buffer); 

		MyInfoList->InsertItem(3,"");
		if (theApp.serverconnect->IsLowID()) MyInfoList->SetItemText(3, 1,GetResString(IDS_IDLOW));
			else MyInfoList->SetItemText(3, 1,GetResString(IDS_IDHIGH));
	}
#endif
//	printf("TODO: MyInfo @ CServerWnd (GUI missing)\n");
}
